//conversion des decimales
function convertVirguleToPoint(value) {
	tmp_val = value;
	return tmp_val.replace(',','\.');
}
//verifie si la case  cocher 'champ'  t coche
function cocheok(champ) {
	var flag = false;
	for (var i=0;i<champ.length;i++) {
		if (champ[i].checked) flag = true;
	}
	if (!flag) { 
		return false;
	} else {
		return true;
	}
}
//vrifie si valeur est un chiffre
function chiffreok(valeur) {
	if (isNaN(convertVirguleToPoint(valeur))) {
		return false;
	} else {
		return true;
	}
}
//vrifie si la chaine contient des caractres valides
function stringok(valeur){
	var exp = new RegExp("[^-+=a-zA-z0-9\.\_\/]");
	var posfilename = valeur.lastIndexOf("\\");
	if (!posfilename){
		var posfilename = valeur.lastIndexOf("/");
	}
	var filename = valeur.substr(posfilename+1,valeur.length);
	
	if (filename.match(exp)){
		return false;
	}else{
		return true;
	}
	
}
//
// Non-Leap year Month days..
anneeBiss = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
// Leap year Month days..
anneeNorm = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
function get_daysofmonth(monthNo, p_year) {
	/* 
	Check for leap year ..
	1.Years evenly divisible by four are normally leap years, except for... 
	2.Years also evenly divisible by 100 are not leap years, except for... 
	3.Years also evenly divisible by 400 are leap years. 
	*/
	monthNo = eval(monthNo)-1;
	if ((p_year % 4) == 0) {
		if ((p_year % 100) == 0 && (p_year % 400) != 0)
			return anneeBiss[monthNo];
	
		return anneeNorm[monthNo];
	} else
		return anneeNorm[monthNo];
}
//vrifie si ladate est une date
function dateok(ladate) {
	tbldate=ladate.split('/');
	jour = tbldate[0];
	mois=tbldate[1];
	annee=tbldate[2];
	if (isNaN(jour) || isNaN(mois) || isNaN(annee)){
		return false;
	}
	moismax = get_daysofmonth(mois,annee);
	if ((jour.length<2) || (mois.length<2) || (annee.length<4)) return false;
	if ((jour>0 && jour<=moismax) && (mois>0 && mois<13) && (annee>=1900 && annee<=9999)) { 
		return true;
	} else {
		return false;
	}	
}

function pointok(valeur) {
 if (valeur.indexOf(".") == -1) {
   //si pas de point
   return false;
 } else {
  //si point
   return true;
 }
}

function remplaceVirguleToPoint(ch) {
  var val = ch.value;
  if (val.length != 0) {
   val = val.replace(",", ".");
   ch.value = val;
   }
}

function averifier(frm, tblelements) {
	var tblchamps = tblelements.split(',');
	var msg = "";
	for(i=0;i<tblchamps.length;i++){
		champs = tblchamps[i].split(':');
		chp = champs[0];
		type =champs[1];
		var error = false;
		switch (type) {
			case "DATETIME":
				var datepart=frm.elements[chp].value.split(' ');
			  if (!dateok(datepart[0])) {
					error = true;
					msg += 'Le format de la date avec heure est non valide au niveau de la date\n';
				}
				var temphr = datepart[1];
				if (temphr.length == 0) {
					error = true;
				  msg += 'Le contenu du champ heures est vide.\n';
				}
				tbltemphr = temphr.split(':');
				if (isNaN(tbltemphr[0]) || tbltemphr[0] <= 0 || tbltemphr[0] > 60) {
				  error = true;
				  msg += 'Le contenu du champ heures est invalide.\n';
				}
				if (isNaN(tbltemphr[1])  || tbltemphr[1] < 0 || tbltemphr[1] > 60 ) {
				  error = true;
				  msg += 'Le contenu du champ minutes est invalide.\n';
				}
				break;
			case "DATE":
				if (!dateok(frm.elements[chp].value)) {
					error = true;
					msg += 'Le format de la date est non valide\n';
				}
				break;      
			case "RADIO":
				if (!cocheok(frm.elements[chp].value)) {
					error = true;
					msg += 'Veuillez cocher une des cases';
				}
				break;
			case "TEXT":
				if (frm.elements[chp].value.length == 0) {
					error = true;
					msg += 'Champ vide nom valide\n';
				}
				break;
			case "DEC":
				frm.elements[chp].value = convertvirguletopoint(frm.elements[chp].value);
				if (!chiffreok(frm.elements[chp].value)) {
					error = true;
					msg += 'Le contenu du champ est invalide';
				}
				break;
			case "HR":
				var temphr = frm.elements[chp].value;
				tbltemphr = temphr.split(':');
				if (isNaN(tbltemphr[0]) || tbltemphr[0] <= 0 || tbltemphr[0] > 60) {
				  error = true;
				  msg += 'Le contenu du champ heures est invalide.\n';
				}
				if (isNaN(tbltemphr[1])  || tbltemphr[1] < 0 || tbltemphr[1] > 60 ) {
				  error = true;
				  msg += 'Le contenu du champ minutes est invalide.\n';
				}
				break;
			case "LISTE":
				if (frm.elements[chp].selectedIndex == 0) {
				  error = true;
				  msg += 'Vous devez faire une slection dans la liste droulante.\n';
				}
				break;
			case "ENTIER":
				if (!chiffreok(frm.elements[chp].value) || pointok(frm.elements[chp].value) || frm.elements[chp].value.length == 0 || frm.elements[chp].value < 1) {
				  error = true;
				  msg += 'Le contenu du champ est invalide.\n';
				}
				break;
			case "TEXT_SPECIAL":
				if (frm.elements[chp].value.length == 0) {
					error = true;
					msg += 'Champ vide nom valide\n';
					break;
				}
				if (!stringok(frm.elements[chp].value)){
					error=true;
					msg += 'Le nom de fichier ne doit pas contenir d\'accents, d\'espace ou d\'apostrophe';
				}
				break;
		}
		//alert(chp+' '+type+' '+frm.elements[chp].value+' '+error);
	}
	if (error) {
			alert(msg);
			return false;
	}
}

/**
 * Ensures a value submitted in a form is numeric and is in a range
 *
 * @param   object   the form
 * @param   string   the name of the form field to check
 * @param   integer  the minimum authorized value
 * @param   integer  the maximum authorized value
 *
 * @return  boolean  whether a valid number has been submitted or not
 */
function checkFormElementInRange(theForm, theFieldName, min, max)
{
    var theField         = theForm.elements[theFieldName];
    var val              = parseInt(theField.value);

    if (typeof(min) == 'undefined') {
        min = 0;
    }
    if (typeof(max) == 'undefined') {
        max = Number.MAX_VALUE;
    }

    // It's not a number
    if (isNaN(val)) {
        theField.select();
        alert(errorMsg1);
        theField.focus();
        return false;
    }
    // It's a number but it is not between min and max
    else if (val < min || val > max) {
        theField.select();
        alert(val + errorMsg2);
        theField.focus();
        return false;
    }
    // It's a valid number
    else {
        theField.value = val;
    }

    return true;
} // end of the 'checkFormElementInRange()' function
