<?php
require('fpdf/fpdf.php');
class PDF_Javascript extends FPDF {

  var $jscript=array();
  var $n_jscript=array();
	var $javascript;
	var $n_js;

	function IncludeJS($script) {
		$this->javascript=$script;
	}
	function IncludeJScript($name,$script) {
		$this->jscript[$name]=$script;
	}


	function _putjavascript() {
		$this->_newobj();
		$this->n_js=$this->n;
		$i=0;
		foreach($this->jscript as $name => $script) {      
      $this->n_jscript[$name]=$this->n_js+1*$i;
      $i++;
		}
    $this->_out('<<');
    $ligne='/Names [';
    $ligne.=' (EmbeddedJS) '.($this->n_js+1).' 0 R ';
    foreach($this->jscript as $name => $script) {
      $ligne.=' ('.$name.') '.($this->n_jscript[$name]+2).' 0 R';
    }
    $ligne.=']';
		$this->_out($ligne);
    $this->_out('>>');
		$this->_out('endobj');
		$this->_newobj();
		$this->_out('<<');
		$this->_out('/S /JavaScript');
		$this->_out('/JS '.$this->_textstring($this->javascript));
		$this->_out('>>');
		$this->_out('endobj');

		foreach($this->jscript as $name => $script) {
//		  $this->_newobj();
//      $this->_out('<<');
//		  $this->_out('/Names [('.$name.') '.($this->n_jscript[$name]+1).' 0 R ]');
//		  $this->_out('>>');
//		  $this->_out('endobj');
		  $this->_newobj();
		  $this->_out('<<');
		  $this->_out('/S /JavaScript');
		  $this->_out('/JS '.$this->_textstring($this->jscript[$name]));
		  $this->_out('>>');
		  $this->_out('endobj');
    }

	}

	function _putresources() {
		parent::_putresources();
		if (!empty($this->javascript)) {
			$this->_putjavascript();
		}
	}

	function _putcatalog() {
		parent::_putcatalog();
		if (isset($this->javascript)) {
			$this->_out('/Names <</JavaScript '.($this->n_js).' 0 R');
//			foreach($this->n_jscript as $name => $nob) {
//			$this->_out('/Names <</JavaScript '.($this->n_jscript[$name]).' 0 R>>');
//			}
			$this->_out('>>');
		}
	}
}
?>
